
<template>
    <div class="login-box">
        <div class="login-logo">
            <div><img src="/img/logo.png"/></div>
        </div>
        <div class="card">
            <div class="card-body login-card-body">
                <p class="login-box-msg">Sign in to start your session</p>
                <div class="alert alert-danger"  v-if="error">
                    <strong>{{ error }}</strong>
                </div>
                <form ref="form">
                    <div class="form-group">
                        <label for="email">E-mail</label>
                        <div class="input-group mb-3">
                            <input id="email" type="email" class="form-control" name="email" 
                                   v-model="email" required autofocus
                                   v-bind:class="{ 'is-invalid': errors.email }">
                            <div class="input-group-append">
                                <div class="input-group-text">
                                    <span class="fas fa-envelope"></span>
                                </div>
                            </div>
                            <span class="invalid-feedback" role="alert" v-if="errors.email !== null">
                                <strong v-for="msg in errors.email">{{ msg }}</strong>
                            </span>
                        </div>
                    </div>
                    <div class="form-group">
                        <label for="password">Password</label>
                        <div class="input-group mb-3">
                            <input id="password" type="password" class="form-control" 
                                   name="password" v-model="password" required
                                   v-bind:class="{ 'is-invalid': errors.password }">
                            <div class="input-group-append">
                                <div class="input-group-text">
                                    <span class="fas fa-lock"></span>
                                </div>
                            </div>
                            <span class="invalid-feedback" role="alert" v-if="errors.password !== null">
                                <strong v-for="msg in errors.password">{{ msg }}</strong>
                            </span>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-8">
                            <div class="icheck-primary">
                                <input type="checkbox" id="remember" v-model="remember">
                                <label for="remember">
                                    Remember Me
                                </label>
                            </div>
                        </div>
                        <!-- /.col -->
                        <div class="col-4">
                            <button type="submit" class="btn btn-primary btn-block" v-on:click.prevent="login">Login</button>
                        </div>
                        <!-- /.col -->
                    </div>
                    <p class="mb-1">
                        <router-link to="/password/reset">
                            I forgot my password
                        </router-link>
                    </p>
                </form>
            </div>
        </div>
    </div>
</template>

<script>
import moment from 'moment';
import auth from '../../auth.js';
import settings from '../../settings';
import FormMixin from '../../mixins/FormMixin.vue';

export default {
    mixins: [FormMixin],
    data() {
        let data = {
            email: null,
            password: null,
            remember: false,
            error: null,
            fields: [
                'email', 'password'
            ],
            errors: {},
            redirectTo: this.$router.resolve({ name: 'dashboard' }).href
        };
        _.each(data.fields, function(field) {
            data.errors[field] = null;
        });
        return data;
    },
    created() {
        $('body').addClass('login-page');
    },
    methods: {
        login() {
            var vm = this;
            var data = {
                email: this.email,
                password: this.password,
                remember: this.remember
            };
            var onSuccess = function(response) {
                var data = {
                    user: response.data.user,
                    auth: {
                        remember: vm.remember,
                        createdAt: moment().format('YYYY-MM-DD HH:mm:ss'),
                        lastRequestAt: moment().format('YYYY-MM-DD HH:mm:ss'),
                        expiresIn: settings.session.expiresIn
                    }
                };
                localStorage.setItem('session_data', JSON.stringify(data));
                // Agregar el CSRF token a la cabecera de autorización a todas las peticiones
                // con axios
                axios.defaults.headers.common['X-CSRF-TOKEN'] = response.data.csrfToken;
                N.vm.$refs.app.isAuthenticated = true;
                $('body').removeClass('login-page');
                var initSidebar = function() {
                    // Init sidebar menu
                    setTimeout(function() {
                        window.adminlte.Treeview._jQueryInterface.call($(this), 'init');
                        $('#profile-modal .modal-body').css('max-height', settings.modalHeight);
                    }, 1000);
                };
                if (vm.$route.query.redirect != null) {
                    vm.$router.push(vm.$route.query.redirect, initSidebar);
                }
                else if (vm.redirectTo) {
                    vm.$router.push(vm.redirectTo, initSidebar);
                }
                else {
                    vm.$router.push({ name: 'dashboard' }, initSidebar);
                }
            };
            var onError = function(error) {
                vm.error = error.response.data.message;
            };
            this.save('post', '/login', data, {
                onSuccess,
                onError
            });
        }
    },
    mounted() {
        document.head.querySelector('title').text = "Login" + " - " + settings.title;
    }
};
</script>